//Create a global object so I can send variables between different functions that shouldn't necessarily be able to talk to each other
window.$my = {};

dojo.require("dojo._base.fx");
dojo.require("dojo.fx");
dojo.require("dojo.NodeList-fx");
dojo.require("dijit.Tooltip");
dojo.require("dijit.form.Button");


dojo.addOnLoad(function() {
/*
 * THIS REQUIRES YOUR INPUT, PART 0
 * 
 * If you need to reveal another set of options when you click some buttons, start here
 * 
 * For each item in the array, fill in this information. The values should be in CSS selector (eg, #id) notation
 *      buttonsThatReveal: the ID(s) of input(s) that user clicks to make another section of questions appear
 *		sectionThatAppears: the ID(s) of sections(s) that will appear after user clicks the input(s) above. 
 *		In your HTML, add class="hidden" to that section, and make sure it does NOT have class="needsSelected" (because the user might never see it)
 *		buttonsThatConceal: the ID(s) of input(s) that user clicks to make the above section disappear again.
 */

	var revealers = [
		{
			buttonsThatReveal: "#up_rtc",
			sectionThatAppears: "#form_rtc_version",
			buttonsThatConceal: "#up_rqm, #up_rrc, #up_jts",
			dontConcealIfSelected: ""
		},
		{
			buttonsThatReveal: "#up_rqm",
			sectionThatAppears: "#form_rqm_issues",
			buttonsThatConceal: "#up_rtc, #up_rrc, #up_jts",
			dontConcealIfSelected: ""
		},
		{
			buttonsThatReveal: "#up_rqm",
			sectionThatAppears: "#rqmWithRCR",
			buttonsThatConceal: "#up_rtc, #up_rrc, #up_jts",
			dontConcealIfSelected: ""
		},
		{
			buttonsThatReveal: "#dbserver_derby_migrate",
			sectionThatAppears: "#form_dbupchoice",
			buttonsThatConceal: "#dbserver_derby, #dbserver_db2, #dbserver_oracle, #dbserver_mssql",
			dontConcealIfSelected: ""
		},
		{
			buttonsThatReveal: "#topology_upgrading, #topology_complex",
			sectionThatAppears: "#form_canMapNetwork",
			buttonsThatConceal: "#topology_simple, #topology_stay_simple",
			dontConcealIfSelected: ""
		},
		{
			buttonsThatReveal: "#need_jts_n",
			sectionThatAppears: "#alreadyMigratedInsight",
			buttonsThatConceal: "#need_jts_y, #need_jts_upgrade",
			dontConcealIfSelected: ""
		},
		{
			buttonsThatReveal: "#need_jts_y",
			sectionThatAppears: "#staySimple",
			buttonsThatConceal: "#need_jts_n, #need_jts_upgrade",
			dontConcealIfSelected: ""
		},
		{
			buttonsThatReveal: "#need_jts_y",
			sectionThatAppears: "#upgrade_topology",
			buttonsThatConceal: "#need_jts_n, #need_jts_upgrade",
			dontConcealIfSelected: ""
		},
		{
			buttonsThatReveal: "#rtc_v_3",
			sectionThatAppears: "#alreadySimpleTopo",
			buttonsThatConceal: "#up_rqm, #up_rrc, #up_jts, #rtc_v_2",
			dontConcealIfSelected: ""
		}
	
	];

	dojo.forEach(revealers, function(c, i) {
		//Cache the variables
		var clickToReveal = dojo.query(c.buttonsThatReveal),
			revealMe = dojo.query(c.sectionThatAppears),
			revealMe_node = c.sectionThatAppears.replace('#',''),
			clickToConceal = dojo.query(c.buttonsThatConceal),
			concealBlocker = dojo.query(c.dontConcealIfSelected);
		
		//Adding functions to the object in the array
		//First, a function to re-hide the section
		c.hideIt = function() {
		
			//Uncheck any inputs in there
			dojo.query('input',revealMe_node).attr("checked",false);
				
			//And hide it
			revealMe.addClass('hidden');
			
		};
		
		c.showIt = function () {
			//Remove the hidden class, thus revealing the section
			revealMe.removeClass('hidden');
			
			//Add a handler to all other buttons to hide the section again
			c.waitToConceal = function() {
			
				clickToConceal.onclick(function() {
					//Blocker?
					var blockChecked = concealBlocker.attr("checked")[0];
					
					if (!blockChecked) {
						//Hide it
						c.hideIt();
						
						//Disconnect this handler after one has been clicked
						dojo.disconnect(c.waitToConceal);
						
						//Re-assign the handler to the main button
						c.waitToReveal();					
					}


				});
							
			};
			
			c.waitToConceal();
			
		};
		
		//On load, check if any of these are selected
		if (clickToReveal.attr('checked')[0]) {
			c.showIt();
		}
		
	//The Main event
		//Function to add the handler
		c.waitToReveal = function() {
			clickToReveal.onclick(function() {
				//Run the function to show the section
				c.showIt();
			
				//Remove this handler (it'll get added back later, if needed)
				dojo.disconnect(c.waitToReveal);
			});
		};
		
		//Add the click event
		c.waitToReveal();
		
			
	});

/*
 * THIS REQUIRES YOUR INPUT, PART 1
 * 
 * If you need to disable certain buttons when an option gets selected look no further
 * 
 * 
 * In the buttons array below, define objects with 4 elements as below. Use CSS notation (ie, for an id, use #id, for classes, use .class) to identify the elements 
 *
 * (1) buttonToClick : The button that you click that needs to disable something
 * (2) buttonToDisable : The button that gets disabled when you click (1)
 * (3) buttonReplacesDisabled : (OPTIONAL) If choosing (1) means another button should be chosen to replace (2), what is it? Use ONLY one id here.
 * (4) buttonFixesDisabled : What buttons can the user click to re-enabled (2)?
 *
 * You can add as many objects as you need to the "buttons" array. I have three below.
 *
 *
 */

	var buttons = [
		{
			buttonToClick: "#up_jts",
			buttonToDisable: "#need_jts_y",
			buttonReplacesDisabled: "#need_jts_upgrade",
			buttonFixesDisabled: "#up_rtc, #up_rqm, #up_rrc"
		},
		{
			buttonToClick: "#up_jts",
			buttonToDisable: "#need_jts_n",
			buttonReplacesDisabled: "#need_jts_upgrade",
			buttonFixesDisabled: "#up_rtc, #up_rqm, #up_rrc"
		},
		{
			buttonToClick: "#rtc_v_3",
			buttonToDisable: "#need_jts_y",
			buttonReplacesDisabled: "need_jts_upgrade",
			buttonFixesDisabled: "#up_rqm, #up_rrc, #rtc_v_2"
		},
		{
			buttonToClick: "#up_rqm",
			buttonToDisable: "#os_i",
			buttonReplacesDisabled: "#os_windows",
			buttonFixesDisabled: "#up_rtc"
		},
		{
			buttonToClick: "#up_rrc",
			buttonToDisable: "#os_i",
			buttonReplacesDisabled: "#os_windows",
			buttonFixesDisabled: "#up_rtc"
		},
		{
			buttonToClick: "#up_rrc",
			buttonToDisable: "#os_zlinux",
			buttonReplacesDisabled: "#os_windows",
			buttonFixesDisabled: "#up_rtc, #up_rqm, #up_jts"
		},
		{
			buttonToClick: "#up_jts",
			buttonToDisable: "#os_i",
			buttonReplacesDisabled: "#os_windows",
			buttonFixesDisabled: "#up_rtc"
		},
		{
			buttonToClick: "#os_i",
			buttonToDisable: "#appserver_tomcat",
			buttonReplacesDisabled: "#appserver_was",
			buttonFixesDisabled: "#os_windows, #os_aix, #os_linux, #os_zlinux, #os_plinux, #os_solaris, #os_zos"
		},
		{
			buttonToClick: "#os_i",
			buttonToDisable: "#dbserver_derby",
			buttonReplacesDisabled: "#dbserver_db2",
			buttonFixesDisabled: "#os_windows, #os_aix, #os_linux, #os_zlinux, #os_plinux, #os_solaris, #os_zos"
		},
		{
			buttonToClick: "#os_i",
			buttonToDisable: "#dbserver_derby_migrate",
			buttonReplacesDisabled: "#dbserver_db2",
			buttonFixesDisabled: "#os_windows, #os_aix, #os_linux, #os_zlinux, #os_plinux, #os_solaris, #os_zos"
		},
		{
			buttonToClick: "#os_i",
			buttonToDisable: "#dbserver_oracle",
			buttonReplacesDisabled: "#dbserver_db2",
			buttonFixesDisabled: "#os_windows, #os_aix, #os_linux, #os_zlinux, #os_plinux, #os_solaris"
		},
		{
			buttonToClick: "#os_i",
			buttonToDisable: "#dbserver_mssql",
			buttonReplacesDisabled: "#dbserver_db2",
			buttonFixesDisabled: "#os_windows, #os_aix, #os_linux, #os_solaris"
		},
		{	
			buttonToClick: "#os_zos",
			buttonToDisable: "#dbserver_oracle",
			buttonReplacesDisabled: "",
			buttonFixesDisabled: "#os_windows, #os_aix, #os_linux, #os_zlinux, #os_plinux, #os_solaris"
		},
		{	
			buttonToClick: "#os_zos",
			buttonToDisable: "#dbserver_mssql",
			buttonReplacesDisabled: "",
			buttonFixesDisabled: "#os_windows, #os_aix, #os_linux, #os_solaris"
		},
		{	
			buttonToClick: "#os_zlinux",
			buttonToDisable: "#dbserver_mssql",
			buttonReplacesDisabled: "",
			buttonFixesDisabled: "#os_windows, #os_aix, #os_linux, #os_solaris"
		},
		{	
			buttonToClick: "#os_plinux",
			buttonToDisable: "#dbserver_mssql",
			buttonReplacesDisabled: "",
			buttonFixesDisabled: "#os_windows, #os_aix, #os_linux, #os_solaris"
		},
		{	
			buttonToClick: "#need_jts_n",
			buttonToDisable: "#dbserver_derby_migrate",
			buttonReplacesDisabled: "dbserver_db2",
			buttonFixesDisabled: "#need_jts_y"
		},
		{	
			buttonToClick: "#need_jts_upgrade",
			buttonToDisable: "#dbserver_derby_migrate",
			buttonReplacesDisabled: "dbserver_db2",
			buttonFixesDisabled: "#need_jts_y"
		},
		{	
			buttonToClick: "#need_jts_y",
			buttonToDisable: "#topology_complex",
			buttonReplacesDisabled: "",
			buttonFixesDisabled: "#need_jts_upgrade, #need_jts_n"
		}
	];
	
	//Run a check for .default items and make sure they've been selected
	dojo.query('input.default','theForm').forEach(function(input){
		//If it's not checked...
		if (!dojo.attr(input,'checked')) {
			
			input.click();
		}
	});
	
	dojo.forEach(buttons, function(b, i) {
	//cache the queries for the buttons
	
		var click = dojo.query(b.buttonToClick);
		var kill = dojo.query(b.buttonToDisable);
		var toReplace = b.buttonReplacesDisabled.replace('#','');
			if (toReplace) {
				var replace = dojo.byId(toReplace);
			}
		var fixers = dojo.query(b.buttonFixesDisabled);

	//add to the object a reusable function to remove the disabled attribute
	//we're doing this for two reasons: adding it to the objects lets me have unique functions, and I will use them later
	//for the reset() function
		b.fixIt = function() {
			kill.attr('disabled',false);
		};
		
	//add to the object a reusable function to disable and do whatever else has to be done
		b.killIt = function() {
			
		// if there's something to replace it with, do that;
		// BUG BUG BUG: If there's a lot going on with conflicting replacement and fixer elements, 
		// I can't guarantee that it'll work the second or subsequent times
			if (toReplace) {
				replace.click();
			}

		//disable the buttons we don't want and uncheck them
		//this is a partial response to the bug above: at the very least, they won't be stuck with a disabled and checked button
			kill.attr({
				'disabled': 'disabled',
				'checked': false
				});
				
		//and finally, add an event handler to re-enable it if those other buttons get clicked
			//first, define the function that adds the handlers
			b.waitForRepairs = function() {
				fixers.onclick(function(node) {
					b.fixIt();
					
					//Remove this event handler. It'll get added back if they click the main one again
					dojo.disconnect(b.waitForRepairs);
					
					//Add the click handler back to the main button
					b.waitForIt();
				
				});
			};
			
			//then, run it
			b.waitForRepairs();
			
		};

	//Certain browser fix: On load/reload, if something is still disabled, fix it. This might get overwritten in a second
		if (kill.attr('disabled')[0]) {
			b.fixIt();
		}
		
	//Certain browser fix: If on load/reload the Click button is checked, run the disable function
		if (click.attr('checked')[0]) {
			//Get the ID; the first (0th) object in the .attr array is the ID name
			var click_node = click.attr("id")[0];
			
			
			//Check if you have a "default" class, indicating that this SHOULD be checked on load
			//Sometimes folks DO want some items pre-checked, but don't want to trigger disabling scripts
			if (!dojo.hasClass(click_node,"default")) {
				//If it's not there, kill the appropriate item as if it had been clicked
				b.killIt();
			}
			
		}

	//The main event listener
		//define the function which will add the handler
		b.waitForIt = function() {
			//Add a click handler to the button
			click.onclick(function() {
				//First, do whatcha came here to do: kill the sucker
				b.killIt();
				
				//THEN, unbind the event. You'll re-bind it when some other button fixes it.
				dojo.disconnect(b.waitForIt);
			});
		};
		
		//Run the function, adding the handler
		b.waitForIt();
					
	});

//Need to simulate my own RESET function
	dojo.query('#form_reset')
		.onclick(function(e) {
		//reset the form
			dojo.byId('theForm').reset();
		//While we're at it, re-enabled any items that might have been disabled
			dojo.forEach(buttons, function(b, i){
				b.fixIt();
				
				//Also unbind any waiting "repair" functions
				dojo.disconnect(b.waitForRepairs);
				
				//And re-bind the click handlers for the main buttons
				b.waitForIt();
			});

		//Look for any highlighted form elements and remove the highlight class	
			dojo.query('td.option_selected','theForm').removeClass('option_selected');
		//And prevent the default behavior for the link
			dojo.stopEvent(e);
		});

//AND, finally, time to submit the thing.

	dojo.query('#theForm')
		.onsubmit(function(e) {
		//Remove any error messages
			dojo.query('p.error').orphan();
		
		//Validation time! Verify that they've selected all options
			var hasSelected = true;

			//Query for .needsSelected, but filter out any .hidden ones
			dojo.query('div.needsSelected:not(.hidden)')
				.forEach(function(node) {
				//Check for a checked input
					var isOneSelected = dojo.query('input:checked',node).length;
					
				//If there isn't one
					if (!isOneSelected) {
					//Create an error message and cache it
						var theError = dojo.query(dojo.create('p',{ 
							innerHTML: errorMsg,
							'class': 'error' 
							}));
					//Find the list here and drop the error message in front of it
						theError.place(dojo.query('ul',node), 'before');

					//Add a handler to any of the inputs here, and remove the error message when they click one
						dojo.query('input', node)
							.onclick(function() {
								theError.orphan();
							});
							
					//If any of this happens, stop the presses
						hasSelected = false;
					}
				});

		// If you're good on each input, let's move on
			if (hasSelected) {

			// DEBUGGING: Uncomment this to get a list of what was submitted in Firebug's Console log. Very useful.
			//				Do NOT leave this uncommented in a production environment.
			//				It will throw errors for people that don't have debugging tools installed (ie, most people)
			//				
			//	var q = dojo.formToJson(this, true);
			//	console.log(q);
				

			/*
			* THIS REQUIRES YOUR INPUT, PART 2
			*
			* In the dojo.query line below, with CSS notation (#id, .class), list any elements or steps that will ALWAYS be shown.
			* For example, if someone must always hit the Power button or whatever, regardless of other options, list it here.
			*
			*
			*/
				dojo.query('#downtime, #theCatches, #backup, #anotherBackup, #clearBrowserCache, #upgradeLicenses, #verify').addClass('seen');


			//turn the values of the form into an object, with name: value
				var o = dojo.formToObject(this);
			
			/*
			* THIS REQUIRES YOUR INPUT, PART 3
			*
			* OK, the formToObject function above turned your form input into a javascript object.
			* Now, you have to turn each value into a variable. You'll be using these values to create an object, so you'll thank me later.
			*
			* You can name the variables whatever you want, but the values are o.NAME, where NAME is the value of the NAME="something" attribute of that form input
			*
			* This isn't strictly necessary, but it gives you something to copy-paste and it improves performance a little bit.
			* 
			*/
				var formUP = o.up,
					formRTCV = o.rtc_v,
					formRQMREQS_rp = o.rqm_reqs_reqpro,
					formRQMREQS_rrc = o.rqm_reqs_rrc,
					formRQMREQS_doors = o.rqm_reqs_doors,
					formRQMREQS_int = o.rqm_reqs_int,
					formRQMDEF_cq = o.rqm_defects_cq,
					formRQMDEF_rtc = o.rqm_defects_rtc,
					formRQMDEF_int = o.rqm_defects_internal,
					formJTS = o.need_jts,
					formOS = o.os,
					formAS = o.appserver,
					formDB = o.dbserver,
					formDBNEW = o.newdb,
					formTOPO = o.topology,
					formNETMOUNT = o.networkMount,
					formREPORTING = o.reporting,
					formLDAP = o.registry;
									
			/*
			* THIS REQUIRES YOUR INPUT, PART 4
			*
			* OK, with the values above, you'll be making an array of objects out of the possible values for the form.
			* 
			* Each object goes like this:
			* toCheck: One of the form variables from directly above.
			* possibleValue: One of the values (the VALUE="something" attribute from the form) that could be selected for that named input. 
			* classToShow: A list of classes, in CSS selector syntax (e.g, '.forWebSphere') to show IF the toCheck value is equal to the possibleValue value.
			*
			* The logic will go like this: IF the toCheck value IS possibleValue, THEN show the blocks with the class classToShow
			*
			* For example, "If for the 'Application Server' field, the user selected 'websphere7', then show the elements with the class 'forWebsphere7'" 
			*
			*/
			
			//Here's the array of values to check, and the classes (in CSS3 selector syntax) to display if someone has selected those options
				var a = [
						{toCheck: formUP, possibleValue: 'rtc', classToShow: '.forRTC'},
						{toCheck: formUP, possibleValue: 'rqm', classToShow: '.forRQM'},
						{toCheck: formUP, possibleValue: 'rrc', classToShow: '.forRRC'},
						{toCheck: formUP, possibleValue: 'jts', classToShow: '.forJustJTS'},
						
						{toCheck: formRTCV, possibleValue: '2', classToShow: '.forRTC2'},
						{toCheck: formRTCV, possibleValue: '3', classToShow: '.forRTC3'},
						
						{toCheck: formRQMREQS_rp, possibleValue: 'reqpro', classToShow: '.forRQMWithReqPro'},
						
						{toCheck: formRQMREQS_rrc, possibleValue: 'rrc', classToShow: '.forRQMWithRRC'},
						
						{toCheck: formRQMREQS_doors, possibleValue: 'doors', classToShow: '.forRQMWithDoors'},
						
						{toCheck: formRQMREQS_int, possibleValue: 'internal', classToShow: '.forRQMWithInternalReqs'},
						
						{toCheck: formRQMDEF_cq, possibleValue: 'cq', classToShow: '.forRQMWithCQ'},
						
						{toCheck: formRQMDEF_rtc, possibleValue: 'rtc', classToShow: '.forRQMWithRTC'},
						
						{toCheck: formRQMDEF_int, possibleValue: 'internal', classToShow: '.forRQMWithInternalDefects'},
						
						{toCheck: formJTS, possibleValue: 'y', classToShow: '.forNewJTS'},
						{toCheck: formJTS, possibleValue: 'upgrade', classToShow: '.forUpgradingJTS'},
						{toCheck: formJTS, possibleValue: 'n', classToShow: '.forHasJTS'},
						
						{toCheck: formOS, possibleValue: 'windows', classToShow: '.forWindows'},
						{toCheck: formOS, possibleValue: 'aix', classToShow: '.forAIX'},
						{toCheck: formOS, possibleValue: 'linux', classToShow: '.forLinux'},
						{toCheck: formOS, possibleValue: 'zlinux', classToShow: '.forZlinux'},
						{toCheck: formOS, possibleValue: 'plinux', classToShow: '.forPlinux'},
						{toCheck: formOS, possibleValue: 'solaris', classToShow: '.forSolaris'},
						{toCheck: formOS, possibleValue: 'i', classToShow: '.forSystemi'},
						//{toCheck: formOS, possibleValue: 'zos', classToShow: '.forSystemz'},
						
						{toCheck: formAS, possibleValue: 'tomcat', classToShow: '.forTomcat'},
						{toCheck: formAS, possibleValue: 'was', classToShow: '.forWAS'},
						
						{toCheck: formDB, possibleValue: 'derby', classToShow: '.forDerby'},
						{toCheck: formDB, possibleValue: 'derby_migrate', classToShow: '.forDBMigration'},
						{toCheck: formDB, possibleValue: 'db2', classToShow: '.forDB2'},
						{toCheck: formDB, possibleValue: 'oracle', classToShow: '.forOracle'},
						{toCheck: formDB, possibleValue: 'mssql', classToShow: '.forMSSQL'},
						
						{toCheck: formDBNEW, possibleValue: 'db2', classToShow: '.forNewDB2'},
						{toCheck: formDBNEW, possibleValue: 'oracle', classToShow: '.forNewOracle'},
						{toCheck: formDBNEW, possibleValue: 'mssql', classToShow: '.forNewMSSQL'},
						
						{toCheck: formTOPO, possibleValue: 'simple', classToShow: '.forSimpleTopo'},
						{toCheck: formTOPO, possibleValue: 'stay_simple', classToShow: '.forSimpleTopo'},
						{toCheck: formTOPO, possibleValue: 'upgrading', classToShow: '.forUpgradingTopo'},
						{toCheck: formTOPO, possibleValue: 'complex', classToShow: '.forDistributedTopo'},
						
						{toCheck: formNETMOUNT, possibleValue: 'yes', classToShow: '.forCanMountNetwork'},
						{toCheck: formNETMOUNT, possibleValue: 'no', classToShow: '.forCannotMountNetwork'},
						
						{toCheck: formREPORTING, possibleValue: 'insight', classToShow: '.forInsight'},
						{toCheck: formREPORTING, possibleValue: 'insight_already', classToShow: '.forInsightAlready'},
						{toCheck: formREPORTING, possibleValue: 'rcr', classToShow: '.forRQMWithRCR'},
						{toCheck: formREPORTING, possibleValue: 'no', classToShow: '.forNoReporting'},
						
						{toCheck: formLDAP, possibleValue: 'ldap', classToShow: '.forLDAP'}
					];

			//Cycle through the array
				dojo.forEach(a, function(field) {
				//If the field matches one of the possible values
					if (field.toCheck === field.possibleValue) {
					//then show those classes
						dojo.query(field.classToShow).addClass('seen');
					}
				});
				
			//Hide the form
				/*
				dojo.query('#qa')
					.wipeOut({duration: 500})
					.play();
				*/
				dojo.style('qa','display','none');
					
			//OK, now show the container with the results
				/*
				dojo.query('#results')
					.style({'display':'block','height':0,'overflow':'hidden'})
					.wipeIn({duration: 1000})
					.play();
				*/
				dojo.style('results','display','block');
				
			//Remove any elements with calculated height = 0
			//Jazz Foundation WI #167601
			/*	dojo.query('#results .bigStep, #results .bigStep div, #results .blockOption')
					.forEach(function(theThing) {
						var elementHeight = dojo.style(theThing,"height");
						
						if (elementHeight === 0) {
							//You would think you could just do a dojo.destroy, but IE has some sort of bug with that
							dojo.query(theThing).orphan();
						}
					});
			*/
				

			//Function for numbering the steps and adding a table of contents: For each H3 that is now visible (aka, it has a calculated height > 0), stick a number in front of it.
				var i = 0;
				
				dojo.create(
					'div',
					{
					'id':'tableOfContents',
					innerHTML: '<h2>' + tocTitle + '<\/h2><ol id="tocSteps"><\/ol>'
					},
					"results",
					"first");
				
				dojo.query('#results h3')
					.forEach(function(item) {
						if (dojo.style(item, "height")) {
						i = i+1;
						
						var stepNumber = '<span class="countNumber">' + i +'<\/span>',
							backToTop = ' <a class="backToTop" href="#tableOfContents">' + backToTopString + '<\/a>';
						
						//Add an ID to the H3 (for linking)
						dojo.attr(item,'id','step' + i);
						
						//Add an <li> to the tocSteps list, with a link
						dojo.create(
						'li',
						{
						innerHTML: '<a href="#step' + i + '">' + item.innerHTML + '<\/a>'
						},
						"tocSteps",
						"last");
						
						//Prepend the step number to the contents of the header
						item.innerHTML = stepNumber + item.innerHTML + backToTop;
												
						}
					});
					
			//Check for visible links and count them
			//This has to happen before you click the PRINT ALL button
			//Links are inline, not block, so you need a different way to figure out height
				$my.internalLinks.forEach(function(item){
					if (dojo.style(item.parentNode, "height")) {
						$my.visibleLinksCount++;

					}
				});

			//Loading Image
				var loadingImg = dojo.create('span', {
									innerHTML: '<img alt="' + loadingString + '" src="../common/loader_orange.gif"> ' + loadingString + '...',
									'class': 'loader'
									});
									
				dojo.place(loadingImg, "results", "before");

			//Fade in the loading graphic
				/*
				dojo.animateProperty({
					node: loadingImg,
					duration: 125,
					properties: {
						opacity: 1
					}
				}).play();
				*/
					
				var progress = 0; //Create variable to track progress of loaded links
				
			//Go through all links (that are internal) and pull in the content
				$my.internalLinks.forEach(function(link, i){
					//Check that the link is actually visible before you do anything fancy
					//To do this, you need to check that the PARENT node has height, b/c anchors are inline elements that don't have height
					//THIS is why you can't put links in a SPAN anywhere. The link has to be in a DIV, PI, LI, H1...
					if (dojo.style(link.parentNode, "height")) {
						
						//Cache some variables
						var	href = link.href, // The href of the link
							linktext = link.innerHTML, //the text of the link
							parent = link.parentNode, // The parent node of the link (likely a P or LI)			
							ajaxDiv = dojo.create('div',{  // A loading sign and wrapper for the AJAX-loaded content
								innerHTML: 'Loading...',
								'class': 'ajax loading' 
								});
					
						dojo.place(ajaxDiv, parent, "after"); //Drop the loading div after the node that holds the link
						
						dojo.xhrGet({
							url: href,
							load: function(response) {
								//Create an empty DIV element to give us a scoped place to search from
								var tempDiv = dojo.create('div');
								//Place the response (the full HTML document) in the div
								tempDiv.innerHTML = response;
								//Grab only the body content (div.body), scoped from that temporary div
								var filteredResponse = dojo.query('div.body', tempDiv);
								
								//Drop the results in that div ... the innerHTML of the BODY is all of the topic's content
								ajaxDiv.innerHTML = filteredResponse[0].innerHTML;
								
								//Remove the 'loading' class from the loading div
								dojo.removeClass(ajaxDiv,'loading');
								
								//Captain subtlety: Animate in and out a highlight color to emphasize change
								/*
								dojo.style(ajaxDiv,"backgroundColor","#FCFFBF");
								dojo.animateProperty({
									node: ajaxDiv,
									duration: 650,
									properties: {
										"backgroundColor": "transparent"
									}
								}).play();
								*/
								
								//Add a class as a bit of data to show that you completed loading this link
								dojo.addClass(link, completedClass);
								
								//Add some text to the linktext to say that its content is just below
								link.innerHTML = linktext + '<em class="loadedLinkText"> (' + loadedLinkText + ')</em>';
								
								progress++; //increment the bar progress
//								console.log('Success! ' + progress + ' out of ' + $my.visibleLinksCount);
								
								if (progress == $my.visibleLinksCount) {
									dojo.destroy(loadingImg);

									dojo.addClass('results','showIt');
									
								}

								},
							error: function(response) {
								ajaxDiv.innerHTML = '<a href="' + href + '">' + loadErrorText + '</a>';
								dojo.addClass(link, attemptedClass);
								
								//Remove the 'loading' class from the loading div
								dojo.removeClass(ajaxDiv,'loading');

								progress++; //increment the bar progress
//								console.log('Error! ' + progress + ' out of ' + $my.visibleLinksCount);
								
								if (progress == $my.visibleLinksCount) {
									dojo.destroy(loadingImg);
									
									dojo.addClass('results','showIt');
								}

								} //End Error function
						}); //End XHR

					} //End IF HEIGHT
				
				}); //End internalLinks.forEach()
								
			//Start Over button
				dojo.query(
					dojo.create('button', {
						'id': 'startOver',
						'type': 'button',
						'title': backToFormTitle,
						innerHTML: backToFormLabel
						})
					)
					.place(loadingImg, "after")
					.onclick(function(e) {
						//Hide #results
						dojo.style('results','display','none');
						dojo.removeClass('results','showIt');
						
						//Bring back form
						dojo.style('qa','display','block');
							
						//Remove count numbers in headers
						dojo.query('span.countNumber')
							.orphan();
							
						//Remove back-to-top links
						dojo.query('a.backToTop')
							.orphan();
						
						//Remove SEEN class from all objects that might have it
						dojo.query('#results .seen')
							.removeClass('seen');
						
						//Reset visible Links Count to 0
						$my.visibleLinksCount = 0;
												
						//Destroy all possibly loaded content
						dojo.query('div.ajax')
							.orphan();
							
						//Destroy all the text that was added to links
						dojo.query('em.loadedLinkText')
							.orphan();
						
						//Destroy the existing loader image
						dojo.destroy(loadingImg);
						
						//Destroy the table of contents
						dojo.destroy('tableOfContents');
						
						//Finally, destroy this button itself
						dojo.destroy(e.target);
						
						dojo.stopEvent(e);
					}); // END START OVER BUTTON
			
			} //End conditional checking if the appropriate buttons are selected
			
		//This is very important: Prevent the form from actually submitting Data anywhere
			dojo.stopEvent(e);
		
		});
	
	//AJAX FUNCTIONS
		var completedClass = 'completed',
			attemptedClass = 'attempted';
			
		$my.visibleLinksCount = 0;

		//Query all links that are NOT external to the information center (marked by the REL attribute or they just begin with http:// things)
		$my.internalLinks = dojo.query('#results a:not([rel=external]):not([href^="http://"])');
		
		//Handler for clicking a single external anchor
/*
		$my.internalLinks.onclick(function(evt) {
				var anchor = this;
				
				//Check if you haven't done this yet
				if (!dojo.hasClass(anchor, completedClass)) {
					var	href = this.href,
						parent = this.parentNode,					
						ajaxDiv = dojo.create('div',{ 
								innerHTML: 'Loading...',
								'class': 'ajax loading' 
								});
						
					dojo.place(ajaxDiv, parent, "after");
										
					dojo.xhrGet({
						url: href,
						load: function(response) {
							//Create an empty DIV element to give us a scoped place to search from
							var tempDiv = dojo.create('div');
							//Place the response (the full HTML document) in the div
							tempDiv.innerHTML = response;
							//Grab only the body, scoped from that temporary div
							var filteredResponse = dojo.query('div.body', tempDiv);
							
							//Drop the results in that div
							ajaxDiv.innerHTML = filteredResponse[0].innerHTML;
							
							//Remove the 'loading' class from the loading div
							dojo.removeClass(ajaxDiv,'loading');
							
							//Captain subtlety: Animate in and out a highlight color to emphasize change
							dojo.style(ajaxDiv,"backgroundColor","#FCFFBF");
							dojo.animateProperty({
								node: ajaxDiv,
								duration: 650,
								properties: {
									"backgroundColor": "transparent"
								}
							}).play();
							
							//Add a class as a bit of data to show that you completed loading this link
							dojo.addClass(anchor, completedClass);
							
						},
						error: function(response) {
							ajaxDiv.innerHTML = 'Something went wrong. Sorry \'bout that! To go directly to the topic, click <a href="' + href + '">here</a>.';
							dojo.addClass(anchor, attemptedClass);
						}
					});
				
				}

				
				//As always, prevent the default action
				dojo.stopEvent(evt);
			});
*/	
});